﻿var gameVars = ["events0", "prev", "antag", "myst", "respect", "extra", "temp0", "temp1", "temp2", gCssSize];
var gamePersists = [gUserChose, gUserSize];

var gameAchieves = ["ep1", "ep2", "ep3", "ep4", "ep5con", "ep5det", "ep5end"];

var gameStartPage = "_begin";

var gameTitle = "Darkness Falls";
var gameDelim = "DarknessFalls";

var gameNumDebugCols = 3;
var gameDoDebug = 0;

var gameNumSaveRows = 3;
var gameNumSaveCols = 3;

var gameScreenWidths = [0, 1280, 1920];
var gameScreenHeights = [0, 900, 1080];

// in a fcn: SetEvent('events0', 'showNeeded');
// events0
var reserved = 0;
var noAudio = 1;
var e1mall = 2;
var e1charles = 3;
var e2scene = 4;
var e2dust = 5;
var e3eve = 6;
var e3chloe = 7;
var e4pros = 8;
var e4jan = 9;

var numEvents0 = 10;

// events specific to Ep2
var e2csiNone = 0;
var e2csiHands = 1;
var e2csiNeck = 2;
var e2csiFeet = 3;
var e2csiComputer = 4;
var e2csiNote = 5;
var e2csiCable = 6;
var e2csiChair = 7;
var e2csiClueNote = 10;
var e2csiClueBruise = 11;
var e2csiClueMonitor = 12;

var typeNone = 0;
var typeAntag = 1;
var typeMyst = 2;
var typeRespect = 3;

var animHelper;
var eId;
var mouseFrames;
var audio;

function SetBanner() 
{
    var banner = document.getElementById("banner");

    var str = "<p id=\"toptext\">Support the making of our games by becoming a <a href=\"https://www.patreon.com/tora\" target=\"_blank\">patron</a>" +
        " or by <a href=\"http://sitepro.arvixe.com/data/s/u/supportmortzeart.com/out/1/\" target=\"_blank\">donating directly</a> to Tlaero and Mortze. Any amount is appreciated.</p>" +
        "<p><a href=\"https://www.patreon.com/tora\" target=\"_blank\"><img class=\"alignnone size-full wp-image-185\" src=\"files/images/ElsaPatreonIraybaner.jpg\" alt=\"ElsaPatreonIraybaner\" width=\"200\" height=\"100\" /></a></p>" +
        "<p id=\"toptext\">Or visit us on <a href=\"http://MortzeArt.com\">MortzeArt.com</a></p>";

    banner.innerHTML = str;
}

function ClearBanner() 
{
    var banner = document.getElementById("banner");
    banner.innerHTML = "";
}

function GameShowScore()
{
    var inStats = ReadVar(gInStats);

    if (inStats)
    {
        var numSetAchieves = CountSetAchieves();
        var numMaxAchieves = CountMaxAchieves();

        if (numSetAchieves < numMaxAchieves)
        {
            var stats = gtEarned + numSetAchieves + gtOutOf + numMaxAchieves + gtAchievements;

            OutputScoreString(stats);
        }
        else
        {
            var bonus = gtBonusText + "<button onclick=\"LoadPage('bonus0');\" >" + gtBonus + "</button> "; 

            OutputScoreString(bonus);
        }

        //OutputScoreString("");
    }
    else
    {
        var menu = " <button class='ctrl' id='menu' onclick=\"GotoStatsPage('_menu');\" title=\"" + gtMenu + "\"></button> ";
        var save = " <button class='ctrl' id='save' onclick=\"SaveState('0');\" title=\"" + gtSave + "\"></button> ";
        var restore = " <button class='ctrl' id='restore' onclick=\"RestoreState('0');\" title=\"" + gtRestore + "\"></button> ";
        var audio = " <button class='ctrl' id='audio' onclick=\"ToggleAudio();\" title=\"" + gtAudio + "\"></button> ";

        var noAudio = CheckEvent("events0", "noAudio");
        if (noAudio)
        {
            audio = " <button class='ctrl' id='noaudio' onclick=\"ToggleAudio();\" title=\"" + gtAudio + "\"></button> ";
        }

        OutputScoreString(save + menu + restore + audio);
    }
}


function ToggleAudio()
{
    var noAudio = CheckEvent("events0", "noAudio");

    if (noAudio)
    {
        ClearEvent("events0", "noAudio");
    }
    else
    {
        SetEvent("events0", "noAudio");
    }

    location.reload();
}


function GameDebugConfigureEvents()
{
    var str;

    str = ConfigureEvents(0);
    //str += ConfigureEvents(1);

    return str;
}

function ConfigureEvents(num)
{
    var eventStr = "events" + num;
    var index;
    var events = ReadVar(eventStr);
    var str = "<br/><br/>Modify " + eventStr + " 0x" + events.toString(16) + " | ";

    var max = window["numEvents" + num];

    for (index = 0; index < max; index++)
    {
        var val = ReadVarBit(eventStr, index);
        str += val + " <button onclick=\"SetVarBit('" + eventStr + "', " + index + ");\">S" + index + "</button> <button onclick=\"ClearVarBit('" + eventStr + "', " + index + ");\">C" + index + "</button> | ";
    }

    return str;
}

function PlaySound(fileName)
{
    var noAudio = CheckEvent("events0", "noAudio");

    if (!noAudio)
    {
        if (typeof (audio) != "undefined" && audio != null)
        {
            audio.pause();
        }

        audio = new Audio("files/audio/" + fileName);
        audio.play();
    }
}

function StopSound()
{
    audio.pause();
}

function Size()
{
    var size = ReadVar("cssSize");
    var str;
    switch (size)
    {
        default:
        case 0:
            str = gtSmall;
            break;

        case 1:
            str = gtMedium;
            break;

        case 2:
            str = gtLarge;
            break;
    }

    return str;
}


function ChoosePict(event)
{
    var isSet = CheckEvent("events0", event);
    if (isSet)
    {
        var str = document.getElementById(gImageId).src;
        str = str.replace(".jpg", "b.jpg");
        document.getElementById(gImageId).src = str;
    }
}


function ChoosePage(event, page1, page2)
{
    var isSet = CheckEvent("events0", event);

    if (typeof (page1) != "undefined" && typeof (page2) != "undefined")
    {
        if (isSet)
        {
            LoadPage(page1);
        }
        else
        {
            LoadPage(page2);
        }
    }
    else if (isSet)
    {
        var page = GetCurrentPageName();
        //page = page.substring(0, page.length - 1);
        page += "b";
        LoadPage(page);
    }
}

function ChooseText(event, text1, text2)
{
    var isSet = CheckEvent("events0", event);
    if (isSet)
    {
        return text1;
    }
    else
    {
        return text2;
    }
}

function C(type)
{
    SetVar("prev", type);

    switch (type)
    {
        case typeAntag:
            AddToVar("antag", 1);
            break;

        case typeMyst:
            AddToVar("myst", 1);
            break;

        case typeRespect:
            AddToVar("respect", 1);
            break;
    }
}

function Prev(antag, myst, respect)
{
    var prev = ReadVar("prev");

    switch (prev)
    {
        case typeAntag:
            return antag;
            break;

        default:
        case typeMyst:
            return myst;
            break;

        case typeRespect:
            return respect;
            break;
    }
}

function Rela(antag, myst, respect)
{
    var rela = CalcRela();

    switch (rela)
    {
        case typeAntag:
            return antag;
            break;
     
        case typeMyst:
        default:
            return myst;
            break;

        case typeRespect:
            return respect;
            break;
    }
}

function CalcRela()
{
    var antag = ReadVar("antag");
    var myst = ReadVar("myst");
    var respect = ReadVar("respect");

    var max = Math.max(antag, myst, respect);

    // Note that, in the case of a tie, this code explicitly chooses 
    // myst over antag and antag over respect
    if (myst == max)
    {
        return typeMyst;
    }
    else if (antag == max)
    {
        return typeAntag;
    }
    else
    {
        return typeRespect;
    }

}

function Won()
{
    var rela = Rela(gtWonAntag, gtWonMyst, gtWonRespect);
    return rela;
}

function Blake()
{
    var rela = Rela(gtBlakeAntag, gtBlakeMyst, gtBlakeRespect);
    return rela;
}

function ClearTemps()
{
    SetVar("temp0", 0);
    SetVar("temp1", 0);
    SetVar("temp2", 0);
}

// the page achieve0 is the one that shows all of them, so 
// the first real page is achive1.  Therefore, index is 
// 1 based instead of 0
function GotoAchieveIfUnlocked(index)
{
    var page = "achieve" + index;

    var achieve = gameAchieves[index - 1];

    val = ReadAchieve(achieve);
    if (val != 0)
    {
        LoadPage(page);
    }

    return false;
}

function SetAchieveImages()
{
    for (var index = 0; index < gameAchieves.length; index++)
    {
        var achieve = gameAchieves[index];
        val = ReadAchieve(achieve);
        if (val == 0)
        {
            // Achievement not unlocked, so we need to flip the image to the bw version.
            var image = document.getElementById(gImageId + index);
            if (image != null)
            {
                var str = image.src;
                str = str.replace(".jpg", "bw.jpg");
                image.src = str;
            }
        }
    }
}

function ValidateAchieve(episode)
{
    var a = 0;
    var b = 0;

    switch (episode)
    {
        case 1:
            a = CheckEvent("events0", "e1mall");
            b = CheckEvent("events0", "e1charles");
            if (a != 0 && b != 0)
            {
                SetAchieve("ep1");
            }
            break;

        case 2:
            a = CheckEvent("events0", "e2scene");
            b = CheckEvent("events0", "e2dust");
            if (a != 0 && b != 0)
            {
                SetAchieve("ep2");
            }
            break;

        case 3:
            a = CheckEvent("events0", "e3eve");
            b = CheckEvent("events0", "e3chloe");
            if (a != 0 && b != 0)
            {
                SetAchieve("ep3");
            }
            break;

        case 4:
            a = CheckEvent("events0", "e4pros");
            b = CheckEvent("events0", "e4jan");
            if (a != 0 && b != 0)
            {
                SetAchieve("ep4");
            }
            break;
    }
}


//function DoPartialControl(side, frames, timeout)
//{
//    animHelper = new AnimHelper(side);
//    animHelper.SetPartialControl(frames, timeout);

//    SetMove(SimpleMove);
//    RunOnPageExit("ClearMove(SimpleMove);");
//}

function DoNormalMouseControl(side)
{
    animHelper = new AnimHelper(side);

    SetMove(SimpleMove);
    RunOnPageExit("ClearMove(SimpleMove);");
}


function E1CheckMall()
{
    var temp0 = ReadVar("temp0");

    ClearTemps();

    if (temp0 > 0)
    {
        GotoPage("e1mall0");
    }
    else
    {
        GotoPage("e1investigation4");
    }
}

function E1CheckInterrogate()
{
    var blake = ReadVar("temp0");
    var won = ReadVar("temp1");

    ClearTemps();

    var diff = blake - won;

    if (Math.abs(diff) <= 2)
    {
        GotoPage("e1interrogation18s");
    }
    else if (diff > 0)
    {
        GotoPage("e1interrogation18b");
    }
    else
    {
        GotoPage("e1interrogation18w");
    }
}


function E2CSI(name)
{
    var prev = ReadVar("temp0");
    var events = ReadVar("temp1");

    var cur = window[name];

    SetVar("temp0", cur);

    if (cur == e2csiNote && prev == e2csiHands)
    {
        SetEvent("temp1", "e2csiClueNote");
        GotoPage("e2csiClueNote");
    }
    else if (cur == e2csiCable && prev == e2csiNeck)
    {
        SetEvent("temp1", "e2csiClueBruise");
        GotoPage("e2csiClueBruise");
    }
    else if (cur == e2csiComputer && prev == e2csiChair)
    {
        SetEvent("temp1", "e2csiClueMonitor");
        GotoPage("e2csiClueMonitor");
    }
    else
    {
        GotoPage(name);
    }
}

function E2CSIRet()
{
    var numClues = E2CSICountClues();
    if (numClues == 0)
    {
        GotoPage("e2csi14");
    }
    else if (numClues < 3) //Note, this assumes there is a max of 3 clues
    {
        GotoPage("e2csi14a");
    }
    else
    {
        GotoPage("e2csi14b");
    }
}

function E2CSICountClues()
{
    var numClues = 0;
    var temp;
    temp = CheckEvent("temp1", "e2csiClueNote");
    if (temp != 0)
    {
        numClues++;
    }

    temp = CheckEvent("temp1", "e2csiClueBruise");
    if (temp != 0)
    {
        numClues++;
    }

    temp = CheckEvent("temp1", "e2csiClueMonitor");
    if (temp != 0)
    {
        numClues++;
    }

    return numClues;
}

function E3CheckEve()
{
    var eve = ReadVar("temp0");

    ClearTemps();

    if (eve != 0)
    {
        SetEvent("events0", "e3eve");
    }
}

function E3CheckCharles()
{
    var charles = CheckEvent("events0", "e1charles");
    if (charles != 0)
    {
        GotoPage("e3scene15a");
    }
    else
    {
        GotoPage("e3scene15c");
    }
}

function E3CheckMorland()
{
    var maxDumb = 3;

    var dumb = ReadVar("temp0");

    ClearTemps();

    if (dumb < maxDumb)
    {
        GotoPage("e3yacht0a");
    }
    else
    {
        SetEvent("events0", "e3chloe");
        GotoPage("e3morland14");
    }
}

function E5CheckJan()
{
    var jan = CheckEvent("events0", "e4jan");

    if (jan != 0)
    {
        GotoPage("e5csi1");
    }
    else
    {
        GotoPage("e5csi5a");
    }
}

function E5CheckCon()
{
    var prev = ReadVar("prev");
    var rela = CalcRela();

    if (prev == rela)
    {
        SetAchieve("ep5con");
    }
}

function E5CheckDet()
{
    var MaxDet = 3;
    var det = ReadVar("temp0");

    ClearTemps();

    if (det == MaxDet)
    {
        SetAchieve("ep5det");
    }
}